
var TimeChooser = function(container){
	var lastSel = 0;
	var lastVal = "00";
	
	var timer = 0;
	var inpBox = new Array();
	
	var scrollU, scrollD;

	var size2 = function(n){
		return ((n<10)?"0":"") + n;
	}
	
	var makePicker = function(){
		var newE = function(tag, attr, styles){
			var e = document.createElement(tag);
			var x,y;
			for(x in attr) e[x] = attr[x];
			for(y in styles) e.style[y] = styles[y];
			return e;
		};

		var cover = newE("div", {}, {width:"115px", height:"20px"});
		container.appendChild(cover);
	
		var scrollCover = newE("div", {} , {width:"23px", cssFloat:"right", styleFloat:"right", height:"30px"});
		cover.appendChild(scrollCover);
		
		scrollU = newE("a", {href:"#"}, {display:"block", height:"9px", width:"23px", margin:"0 0", fontSize:"1pt",
												background:"url('images/timebutton.png') no-repeat #f0f0f0"});
												
		scrollD = newE("a", {href:"#"}, {display:"block", height:"9px", width:"23px", margin:"2px 0 0 0", fontSize:"1pt",
												background:"url('images/timebutton.png') no-repeat #f0f0f0", backgroundPosition:"0 -11px"});
		scrollCover.appendChild(scrollU);
		scrollCover.appendChild(scrollD);
		
		var inputCover = newE("div", {} , {border:"1px solid #000000", background:"#ffffff", width:"85px", height:"20px", overflow:"hidden"});
		cover.appendChild(inputCover);
		
		var inputStyle = {border:"none", width:"22px", margin:"0 0",fontFamily:"Courier New", height:"18px", background:"#fff"};
		var params = {type:"text", maxlength:2, size:1};
		inpBox[0] = newE("input", params, inputStyle);
		inpBox[1] = newE("input", params, inputStyle);
		inpBox[2] = newE("input", params, inputStyle);
		
		inpBox[0].style.marginLeft = "3px";
		var colon = newE("span", {innerHTML:": "}, {});
		
		inputCover.appendChild(inpBox[0]);
		inputCover.appendChild(colon);
		inputCover.appendChild(inpBox[1]);
		inputCover.appendChild(inpBox[2]);
		
		var t = new Date();
		
		inpBox[1].value = size2(t.getMinutes());
		
		t = t.getHours();
		inpBox[2].value = (t>11)?"PM":"AM";
		if (t>12) t=t-12;
		if (t==0) t=12;
		lastVal = inpBox[0].value = size2(t);
	};
	makePicker();
	
	var checkInt = function(val, low, high){
		var x = parseInt(val,10);
		var ret = parseInt(lastVal,10);
		if(x>=low && x<=high)
			if((x+"")==val || ("0"+x)== val)
				ret = x;
		return size2(ret);
	};

	for (var i=0;i<3;i++) inpBox[i].ic=i;
	inpBox[0].range = [1,12];
	inpBox[1].range = [0,59];
	
	
	inpBox[0].onfocus = inpBox[1].onfocus = inpBox[2].onfocus = function(){
		lastSel = this.ic;
		lastVal = this.value;
	};
	inpBox[0].onblur = inpBox[1].onblur = function(){
		this.value = checkInt(this.value, this.range[0], this.range[1]);
	};
	inpBox[2].onblur = function(){
		var x = this.value.toUpperCase();
		if (x=="AM" || x=="PM") this.value = x;
		else this.value = lastVal;
	};
	
	var shiftval = function(shift){
		var x = parseInt(inpBox[lastSel].value,10);
		x += shift;
		if(x<inpBox[lastSel].range[0]) x=inpBox[lastSel].range[1];
		if(x>inpBox[lastSel].range[1]) x=inpBox[lastSel].range[0];
		lastVal = size2(x);
		inpBox[lastSel].value = lastVal;
	};
	var switchAMPM = function(){
		inpBox[2].value = (inpBox[2].value.toUpperCase()=="AM")?"PM":"AM";
	};
	var loopShift = function(shift){
		shiftval(shift);
		timer = window.setTimeout(
			function(){loopShift(shift);},
			150
		);
	};
	
	
	scrollU.ns =1;
	scrollD.ns =-1;
	
	scrollU.onmousedown = scrollD.onmousedown = function(){
		if (lastSel==2) switchAMPM();
		else {
			var x = this.ns;
			shiftval(x);
			timer = window.setTimeout(
				function(){loopShift(x);},
				500
			);
		}
		return false;
	};
	
	scrollU.onmouseup = scrollD.onmouseup = function() {
		window.clearTimeout(timer);
	};
	
	scrollU.onclick = scrollD.onclick = function() { return false; };
	scrollU.onmouseout = scrollD.onmouseout = function(){
		inpBox[lastSel].focus();
		inpBox[lastSel].select();
		this.style.backgroundColor = "#f0f0f0";
		inpBox[lastSel].style.backgroundColor = "#fff";

	};
	scrollU.onmouseover = scrollD.onmouseover = function(){
		this.style.backgroundColor = "#C4DDEE";
		inpBox[lastSel].style.backgroundColor = "#eee";
	};
	
	this.getVal = function(){
		return checkInt(inpBox[0].value, inpBox[0].range[0], inpBox[0].range[1]) + "-"
			 + checkInt(inpBox[1].value, inpBox[1].range[0], inpBox[1].range[1]) + "-"
			 + inpBox[2].value;
	};
	
	this.setVal = function(val){
		var t = val.split("-");
		inpBox[0].value = checkInt(t[0], inpBox[0].range[0], inpBox[0].range[1]);
		inpBox[1].value = checkInt(t[1], inpBox[1].range[0], inpBox[1].range[1]);
		inpBox[2].value = t[2];
		lastVal = inpBox[lastSel].value;
	};
}